VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form Form1 
   Caption         =   "howto_compare_directories"
   ClientHeight    =   3810
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3810
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ListView lvwFiles 
      Height          =   2295
      Left            =   120
      TabIndex        =   5
      Top             =   1320
      Width           =   4455
      _ExtentX        =   7858
      _ExtentY        =   4048
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Directory 1"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Directory 2"
         Object.Width           =   2540
      EndProperty
   End
   Begin VB.CommandButton cmdCompare 
      Caption         =   "Compare"
      Height          =   375
      Left            =   1800
      TabIndex        =   4
      Top             =   840
      Width           =   975
   End
   Begin VB.TextBox txtDir2 
      Height          =   285
      Left            =   1080
      TabIndex        =   2
      Top             =   480
      Width           =   3495
   End
   Begin VB.TextBox txtDir1 
      Height          =   285
      Left            =   1080
      TabIndex        =   0
      Top             =   120
      Width           =   3495
   End
   Begin VB.Label Label1 
      Caption         =   "Directory 2:"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Directory 1:"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
Dim base_dir As String
        
    base_dir = App.Path

    txtDir1.Text = base_dir & "\Dir1\*.*"
    txtDir2.Text = base_dir & "\Dir2\*.*"
End Sub

Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    wid = ScaleWidth - txtDir1.Left - 120
    If wid < 120 Then wid = 120

    txtDir1.Width = wid
    txtDir2.Width = wid
    cmdCompare.Left = (ScaleWidth - cmdCompare.Width) / 2

    wid = ScaleWidth - lvwFiles.Left - 120
    If wid < 120 Then wid = 120
    hgt = ScaleHeight - lvwFiles.Top - 120
    If hgt < 120 Then hgt = 120
    lvwFiles.Width = wid
    lvwFiles.Height = hgt

    wid = (lvwFiles.Width - 120) / 2
    lvwFiles.ColumnHeaders.Item(1).Width = wid
    lvwFiles.ColumnHeaders.Item(2).Width = wid
End Sub

Private Sub cmdCompare_Click()
Dim file_names1() As String
Dim file_names2() As String
Dim num_file_names1 As Integer
Dim num_file_names2 As Integer
Dim file_name As String
Dim i1 As Integer
Dim i2 As Integer
Dim i As Integer

    ' Get the files in the first directory.
    file_name = Dir$(txtDir1.Text)
    num_file_names1 = 0
    Do While Len(file_name) > 0
        num_file_names1 = num_file_names1 + 1
        ReDim Preserve file_names1(1 To num_file_names1)
        file_names1(num_file_names1) = file_name

        file_name = Dir$()
    Loop

    ' Get the files in the second directory.
    file_name = Dir$(txtDir2.Text)
    num_file_names2 = 0
    Do While Len(file_name) > 0
        num_file_names2 = num_file_names2 + 1
        ReDim Preserve file_names2(1 To num_file_names2)
        file_names2(num_file_names2) = file_name

        file_name = Dir$()
    Loop

    ' Sort the lists of files.
    Quicksort file_names1, 1, num_file_names1
    Quicksort file_names2, 1, num_file_names2

    ' Compare.
    lvwFiles.ListItems.Clear
    i1 = 1
    i2 = 1
    Do While (i1 <= num_file_names1) And (i2 <= num_file_names2)
        If file_names1(i1) = file_names2(i2) Then
            ' They match.
            AddFiles file_names1(i1), file_names2(i2)
            i1 = i1 + 1
            i2 = i2 + 1
        ElseIf file_names1(i1) < file_names2(i2) Then
            ' Display the directory 1 file.
            AddFiles file_names1(i1), ""
            i1 = i1 + 1
        ElseIf file_names1(i1) > file_names2(i2) Then
            ' Display the directory 2 file.
            AddFiles "", file_names2(i2)
            i2 = i2 + 1
        End If
    Loop

    ' Display remaining directory 1 files.
    For i = i1 To num_file_names1
        AddFiles file_names1(i), ""
    Next i

    ' Display remaining directory 2 files.
    For i = i2 To num_file_names2
        AddFiles "", file_names2(i)
    Next i
End Sub

' Sort the array of Strings.
Sub Quicksort(list() As String, ByVal min As Long, ByVal max As Long)
Dim med_value As String
Dim hi As Long
Dim lo As Long
Dim i As Long

    ' If min >= max, the list contains 0 or 1 items so it is sorted.
    If min >= max Then Exit Sub

    ' Pick the dividing value.
    i = Int((max - min + 1) * Rnd() + min)
    med_value = list(i)

    ' Swap it to the front.
    list(i) = list(min)

    lo = min
    hi = max
    Do
        ' Look down from hi for a value < med_value.
        Do While list(hi) >= med_value
            hi = hi - 1
            If hi <= lo Then Exit Do
        Loop
        If hi <= lo Then
            list(lo) = med_value
            Exit Do
        End If

        ' Swap the lo and hi values.
        list(lo) = list(hi)

        ' Look up from lo for a value >= med_value.
        lo = lo + 1
        Do While list(lo) < med_value
            lo = lo + 1
            If lo >= hi Then Exit Do
        Loop
        If lo >= hi Then
            lo = hi
            list(hi) = med_value
            Exit Do
        End If

        ' Swap the lo and hi values.
        list(hi) = list(lo)
    Loop

    ' Sort the two sublists.
    Quicksort list, min, lo - 1
    Quicksort list, lo + 1, max
End Sub

' Add two file names to the ListView.
Private Sub AddFiles(ByVal file1 As String, ByVal file2 As String)
Dim list_item As ListItem

    Set list_item = lvwFiles.ListItems.Add(Text:=file1)
    list_item.ListSubItems.Add Text:=file2
End Sub
